<template>
	<!-- 回退审批弹窗 -->
	<el-dialog v-model="reviewVisibleDialog" class="le-dialog" title="回退审批" width="700" destroy-on-close :close-on-click-modal="false">
		<el-form ref="formRef" v-loading="uploadLoading" label-position="top" element-loading-text="图片上传中..." :model="form" label-width="80px">
			<el-form-item label="回退到" prop="nodeName" :rules="[{ required: true, message: '请选择回退节点' }]">
				<el-select v-model="form.nodeName" placeholder="请选择回退节点">
					<el-option v-for="item in rollbackOptions" :key="item" :label="item" :value="item" />
				</el-select>
			</el-form-item>
			<el-form-item label="回退原因" prop="content">
				<el-input v-model="form.content" type="textarea" placeholder="请输入回退原因" maxlength="64" show-word-limit> </el-input>
			</el-form-item>
			<el-form-item v-if="false" prop="attachment" label="附件" class="example-img-box">
				<!--'.docx', '.doc', '.pptx', '.ppt', '.xlsx', '.xls', '.zip', '.csv', '.pdf', '.png', '.jpg'  因前端不支持图片以外格式,所以注释 -->
				<FileUpload
					v-model="form.attachment"
					source="project"
					return="array"
					:limit="5"
					:file-size="10"
					:accept="['.png', '.jpg']"
					@success="clearValidate"
				/>
			</el-form-item>
		</el-form>
		<template #footer>
			<span class="dialog-footer">
				<el-button :loading="btnDisabled" class="dialog-btn" @click="closeDialog">取 消</el-button>
				<el-button type="primary" :loading="btnDisabled" class="dialog-btn" @click="submitForm">确 定</el-button>
			</span>
		</template>
	</el-dialog>
</template>

<script setup>
import { computed, onMounted, reactive, ref } from 'vue'
import FileUpload from '@/components/FileUpload.vue'
import { processPreviousNodeNameApi, processTaskJumpApi } from '@/api/flow/processTask'
import { ElMessage } from 'element-plus'

const props = defineProps({
	modelValue: {
		type: Boolean,
		default: false
	},
	taskId: {
		type: String,
		default: undefined
	}
})
const btnDisabled = ref(false)
const form = reactive({
	nodeName: '',
	content: ''
	// attachment: []
})
const formRef = ref(null)
const uploadLoading = ref(false)
const rollbackOptions = ref([])

const $myEmit = defineEmits(['update:modelValue', 'successCb'])

// 回退节点列表
const getProcessPreviousNodeNameApi = async () => {
	const res = await processPreviousNodeNameApi(props.taskId)
	rollbackOptions.value = res || []
}

const submitForm = () => {
	btnDisabled.value = true
	const formData = { ...form, taskId: props.taskId }
	formRef.value
		.validate()
		.then(async valid => {
			if (valid) {
				const data = await processTaskJumpApi(formData)
				if (!data) {
					ElMessage({
						message: '执行失败',
						type: 'error'
					})
					return false
				}
				$myEmit('successCb')
				closeDialog()
				btnDisabled.value = false
			}
		})
		.catch(err => {
			btnDisabled.value = false
		})
}

const closeDialog = () => {
	$myEmit('update:modelValue', false)
}

const clearValidate = () => {}

const reviewVisibleDialog = computed({
	get() {
		return props.modelValue
	},
	set(val) {
		$myEmit('update:modelValue', val)
	}
})

onMounted(() => {
	getProcessPreviousNodeNameApi()
})
</script>

<style scoped lang="scss">
.example-img-box {
	width: 100% !important;
}

.example-img-box .el-form-item__content {
	display: block;
}

.dialog-footer {
	.dialog-btn {
		animation: throttle 2s step-end forwards;
	}
	.dialog-btn:active {
		animation: none;
	}
}

@keyframes throttle {
	from {
		pointer-events: none;
	}
	to {
		pointer-events: all;
	}
}
</style>
